# coding: utf-8

from java.text import SimpleDateFormat
import json
from uuid import uuid4
from datetime import datetime
try:
    from ru.curs.showcase.core.jython import JythonDTO
    from ru.curs.showcase.app.api import MessageType, UserMessage
except:
    from ru.curs.celesta.showcase import JythonDTO
from ru.curs.celesta.showcase.utils import XMLJSONConverter
from umk._umk_orm import specialityCursor
from nci.xform.personCard import check_snils
from fias.xforms.addressSearch import addressSearchDict, addressEditDict, saveAdress
from nci.functions.persons import getPersonIdBySid
from edu._edu_orm import courseCursor
from medstaff._medstaff_orm import student_certificateCursor, certificate_addressCursor
from nci._nci_orm import edu_organizationCursor, personCursor

def cardData(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    u'''Карточка цикла аккредитации'''
    session = json.loads(session)
    sid = session['sessioncontext']['sid']
    currentId = session['sessioncontext']['related']['gridContext']['currentRecordId']
    student_certificate = student_certificateCursor(context)
    certificate_address = certificate_addressCursor(context)
#     course_cycle = course_cycleCursor(context)
    course = courseCursor(context)
    speciality = specialityCursor(context)
    person = personCursor(context)
    edu_organization = edu_organizationCursor(context)

    sdf = SimpleDateFormat('dd.MM.yyyy')
    sdfCard = SimpleDateFormat('yyyy-MM-dd')
    
    xformsdata = {"schema":
                    {"@xmlns": "",
                     "record": {
                        "id":"",
                        "surname": "",
                        "patronymic": "",
                        "name": "",
                        "snils": "",
                        "organization_name":"",
                        "organization_head":"",
                        "birth_date":"",
                        "position":"",
                        "specialization_name":"",
                        "program_name":"",
                        "hours":"",
                        "dateTo":"",
                        "dateFrom":"",
                        "price":"",
                        "org_address":"",
                        "edu_organization_name":""},
                    'address':''}}    
    
    if add == 'edit':
        student_certificate.get(currentId)
#         course_cycle.get(student_certificate.cycle_id)
#         course.get(course_cycle.course_id)
        course.get(student_certificate.course_id)
        speciality.get(course.speciality_id)
        edu_organization.get(course.edu_organization_id)
        xformsdata['schema']['record']['id'] = student_certificate.uid
        xformsdata['schema']['record']['name'] = student_certificate.name
        xformsdata['schema']['record']['surname'] = student_certificate.surname
        xformsdata['schema']['record']['patronymic'] = student_certificate.patronymic
        xformsdata['schema']['record']['snils'] = student_certificate.snils
        xformsdata['schema']['record']['organization_name'] = student_certificate.organization_name
        xformsdata['schema']['record']['organization_head'] = student_certificate.organization_head
        xformsdata['schema']['record']['position'] = student_certificate.position
        xformsdata['schema']['record']['birth_date'] = sdfCard.format(student_certificate.birth_date) if student_certificate.birth_date else ''
        xformsdata['schema']['record']['specialization_name'] = speciality.name
        xformsdata['schema']['record']['program_name'] = course.name
#         xformsdata['schema']['record']['dateTo'] = sdf.format(course_cycle.end_date)
        xformsdata['schema']['record']['dateTo'] = ''
#         xformsdata['schema']['record']['dateFrom'] = sdf.format(course_cycle.start_date)
        xformsdata['schema']['record']['dateFrom'] = ''
        xformsdata['schema']['record']['price'] = course.edu_cost
        xformsdata['schema']['record']['edu_organization_name'] = edu_organization.shortname
        xformsdata['schema']['record']['hours'] = course.hours
        xformsdata['schema']['record']['org_address'] = student_certificate.org_address
        certificate_address.get(student_certificate.uid)
        xformsdata['schema']['address'] = addressEditDict(context, certificate_address).get("address")
        xformssettings = {"properties": {
                            "event":[
                                {"@name":"single_click",
                                "@linkId": "1",
                                "action": {
                                    '#sorted': [
                                        {"main_context": 'current'},
                                        {"datapanel": {
                                            "@type": "current",
                                            "@tab": "current",
                                            "element": {
                                                "@id":"certificationMethodGrid"}}}]}},
                                        {"@name":"single_click",
                                        "@linkId": "2",
                                        "action":{
                                            '#sorted': [
                                                {"main_context": 'current'},
                                                {"datapanel": {
                                                    "@type": "current",
                                                    "@tab": "current",
                                                    "element": {
                                                        "@id":elementId,
                                                        "add_context":"hide"}}}]}}]}}
    else:
        person_id = getPersonIdBySid(context, sid)
        person.get(person_id)
        id = unicode(uuid4())
#         course_cycle.get(currentId)
#         course.get(course_cycle.course_id)
        course.get(currentId)
        speciality.get(course.speciality_id)
        edu_organization.get(course.edu_organization_id)
        xformsdata['schema']['address'] = addressSearchDict().get('address')
        xformsdata['schema']['record']['id'] = id
        xformsdata['schema']['record']['name'] = person.name
        xformsdata['schema']['record']['surname'] = person.surname
        xformsdata['schema']['record']['patronymic'] = person.patronymic
        xformsdata['schema']['record']['snils'] = person.snils
        xformsdata['schema']['record']['birth_date'] = sdfCard.format(person.birthDate) if person.birthDate else ''       
        
        xformsdata['schema']['record']['specialization_name'] = speciality.name
        xformsdata['schema']['record']['program_name'] = course.name
#         xformsdata['schema']['record']['dateTo'] = sdf.format(course_cycle.end_date)
#         xformsdata['schema']['record']['dateFrom'] = sdf.format(course_cycle.start_date)
        xformsdata['schema']['record']['dateTo'] = ''
        xformsdata['schema']['record']['dateFrom'] = ''
        xformsdata['schema']['record']['price'] = course.edu_cost
        xformsdata['schema']['record']['edu_organization_name'] = edu_organization.shortname
        xformsdata['schema']['record']['hours'] = course.hours
        
        if elementId == 'downloadCertificateFromCertCard':
            event = {"@name":"single_click",
                     "@linkId": "1",                          
                     "action":{
                        "@keep_user_settings":'true',
                        '#sorted': [
                            {"main_context": 'current'},                                
                            {"datapanel": {
                                "@type": "current",
                                "@tab": "current",
                                "element": [
                                    {"@id":"studentCycleGrid",
                                    "add_context": id},
                                    {"@id":"certificatesGrid"}]}}]}}
        else:
            event = {"@name":"single_click",
                    "@linkId": "1",
                    "action":{
                    '#sorted': [
                        {"main_context": 'current'},
                        {"navigator":{"@element":'medstaffRequests'}
#                                                         "datapanel": {"@type": "medstaff.datapanel.certificatesDatapanel.datapanel.cl",
#                                                                       "@tab": "1",
#                                                                       "element": {"@id":"certificatesGrid",
#                                                                                   "add_context": id}
#                                                                        }
                         }]}}
        xformssettings = {"properties":{
                            "event": [
                                event,
                                {"@name":"single_click",
                                "@linkId": "2",
                                "action":{
                                    '#sorted': [
                                        {"main_context": 'current'},
                                        {"datapanel": {
                                            "@type": "current",
                                            "@tab": "current",
                                            "element": {
                                                "@id":elementId,
                                                "add_context":"hide"}}}]}}]}}

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(xformsdata)),
                     XMLJSONConverter.jsonToXml(json.dumps(xformssettings)))


def cardDataSave(context, main=None, add=None, filterinfo=None, session=None, elementId=None, xformsdata=None):
    session = json.loads(session)['sessioncontext']
    sid = session['sid']
    data = json.loads(xformsdata)['schema']['record']
    sdf = SimpleDateFormat('yyyy-MM-dd')
    currentId = session['related']['gridContext']['currentRecordId']
    student_certificate = student_certificateCursor(context)
    person_id = getPersonIdBySid(context, sid)
    name = data['name']
    surname = data['surname']
    patronymic = data['patronymic']
    snils  = data['snils']
    organization_name = data['organization_name']
    organization_head = data['organization_head']
    org_address = data['org_address']
    birth_date = sdf.parse(data['birth_date'])
    position = data['position']
    
    snils_result = check_snils(snils)
    try:
        sum = int(snils[-2:])
        if sum != snils_result:
            raise Exception('1')
    except:
        return context.error(u'Неверный СНИЛС')
    
    if add == 'edit':
        student_certificate.get(currentId)
    else:    
        certificate = data['id']

        student_certificate.issue_date = datetime.now()
        student_certificate.uid = certificate 
        student_certificate.course_id = currentId
        # Статус - На проверке
        student_certificate.status = 2
        count = student_certificate.count()
        rounds = count//1000000
        prefix = chr(65+rounds//26)+chr(65+rounds%26)
        number = '0'*(6-len(str(count%1000000))) + str(count)
        student_certificate.certificate_number = '%s-%s-%s'%(prefix,number,SimpleDateFormat('yyyy').format(datetime.now()))
    
    student_certificate.person_id = person_id
    student_certificate.name = name
    student_certificate.surname = surname
    student_certificate.patronymic = patronymic
    student_certificate.snils = snils
    student_certificate.organization_name = organization_name
    student_certificate.organization_head = organization_head
    student_certificate.org_address = org_address
    student_certificate.position = position
    student_certificate.birth_date = birth_date
    if add == 'edit':
        student_certificate.update()
    else:
        student_certificate.insert()
        
    address = json.loads(xformsdata)['schema']['address']    
    certificate_address = certificate_addressCursor(context)
    if certificate_address.tryGet(student_certificate.uid):
        saveAdress(certificate_address, address)
        certificate_address.update()
    else:
        certificate_address.certificate_id = student_certificate.uid
        saveAdress(certificate_address, address)
        certificate_address.insert()
    certificate_address.close()
    
    
def cancelRequestData(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    u'''Карточка отмены заявки на программу'''   

    string_bool = lambda x: x and 'true' or 'false'

    # Структура данных
    xforms_data = {
        'schema': {
            '@xmlns': '',
            'data': {
                'form_text': u'Вы действительно хотите отозвать заявку на данную программу?'}}}

    # Первоначальная xforms_settings
    xforms_settings = {
        'properties': {
            'event': [
                {'@name': 'single_click',
                 '@linkId': '1',
                 'action': {
                    '@keep_user_settings': 'false',
                    '#sorted': [
                      {'main_context': 'current'},
                      {'datapanel': {
                          '@type': 'current',
                          '@tab': 'current',
                          'element': {
                              '@id': 'certificationRequestGrid',
                              'add_context': ''}}}]}},
                {'@name': 'single_click',
                 '@linkId': '2',
                 'action': {
                    '@keep_user_settings': 'true',
                    '#sorted': [
                      {'main_context': 'current'},
                      {'datapanel': {
                          '@type': 'current',
                          '@tab': 'current',
                          'element': {
                              '@id': 'certificationRequestGrid',
                              'add_context': ''}}}]}}]}}

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(xforms_data)),
                     XMLJSONConverter.jsonToXml(json.dumps(xforms_settings)))         
    
def cancelRequestSave(context, main=None, add=None, filterinfo=None, session=None, elementId=None, xformsdata=None):
    u'''Отмена заявки на программу'''
    student_certificateCur = student_certificateCursor(context)
    if student_certificateCur.tryGet(add):
        student_certificateCur.status = 23
        student_certificateCur.update()
    
    